// #region Algemeen
//const IP = prompt('geef publiek IP', 'http://127.0.0.1:5000');
const IP = window.location.hostname + ':5000';
//const IP = '169.254.10.1' + ':5000';

const socket = io.connect(IP);
let van,
  tot,
  t,
  v,
  l,
  co2,
  co,
  sensor = ['4', '7'];
const enableSocketIO = function() {
  socket.on('connected', function() {
    console.log('connected');
  });
  socket.on('geschiedenisChartData', function(dataChart) {
    dataChart.newdata = [];
    dataChart.newlabels = [];
    for (let i = 0; i < dataChart.data.length; i++) {
      dataChart.newdata.push({ x: new Date(dataChart.labels[i]), y: dataChart.data[i] });
    }
    const new_data = {
      datasets: [
        {
          label: 'Temperatuur',
          backgroundColor: ['#ffed00'],
          borderwidth: 1,
          borderColor: ['#ffed00'],
          fill: false,
          data: dataChart.newdata
        }
      ]
    };
    drawGraph(new_data);
  });
};

const resetMenu = function() {
  for (let i of [t, v, l, co2, co]) {
    i.classList = 'c-menu-item';
  }
};
const drawGraph = function(data) {
  let chart_place = document.getElementById('myChart').getContext('2d');
  let chart = new Chart(chart_place, {
    type: 'line',
    data: data,
    options: {
      responsive: true,
      scales: {
        xAxes: [
          {
            type: 'time',
            time: {
              unit: 'hour'
            },

            ticks: {
              autoSkip: true,
              autoSkipPadding: 50,
              minRotation: 30,
              fontColor: '#ffed00'
            },
            display: true,
            scaleLabel: {
              display: true
            },
            gridLines: {
              color: '#aa9800'
            }
          }
        ],
        yAxes: [
          {
            scaleLabel: {
              display: true
            },
            ticks: {
              min: 0,
              fontColor: '#ffed00'
            },
            gridLines: {
              color: '#aa9800'
            }
          }
        ]
      },
      gridLines: {
        color: '#ffed00',
        drawBorder: true
      }
    }
  });
};

const init = function() {
  menu = document.querySelector('.js-menu-button');
  menuTemperatuur = document.querySelector('.js-menu-temperatuur');
  menuVochtigheid = document.querySelector('.js-menu-vochtigheid');
  menuLuchtdruk = document.querySelector('.js-menu-luchtdruk');
  menuCo2 = document.querySelector('.js-menu-co2');
  menuCo = document.querySelector('.js-menu-co');
  menuContent = document.querySelector('.js-menu-content');
  menu.addEventListener('click', function() {
    menuContent.classList.toggle('c-nav-dropdown-show');
  });
  menuTemperatuur.addEventListener('click', function() {
    title.innerHTML = 'Temperatuur';
    sensor = ['7', '4'];
    van = document.querySelector('.js-date-van').value + ' ' + document.querySelector('.js-time-van').value;
    tot = document.querySelector('.js-date-tot').value + ' ' + document.querySelector('.js-time-tot').value;
    socket.emit('geschiedenis', { van, tot, sensor });
  });
  menuVochtigheid.addEventListener('click', function() {
    title.innerHTML = 'Vochtigheid';
    sensor = ['3'];
    van = document.querySelector('.js-date-van').value + ' ' + document.querySelector('.js-time-van').value;
    tot = document.querySelector('.js-date-tot').value + ' ' + document.querySelector('.js-time-tot').value;
    socket.emit('geschiedenis', { van, tot, sensor });
  });
  menuLuchtdruk.addEventListener('click', function() {
    title.innerHTML = 'Luchtdruk';
    sensor = ['5'];
    van = document.querySelector('.js-date-van').value + ' ' + document.querySelector('.js-time-van').value;
    tot = document.querySelector('.js-date-tot').value + ' ' + document.querySelector('.js-time-tot').value;
    socket.emit('geschiedenis', { van, tot, sensor });
  });
  menuCo2.addEventListener('click', function() {
    title.innerHTML = 'CO2';
    sensor = ['2'];
    van = document.querySelector('.js-date-van').value + ' ' + document.querySelector('.js-time-van').value;
    tot = document.querySelector('.js-date-tot').value + ' ' + document.querySelector('.js-time-tot').value;
    socket.emit('geschiedenis', { van, tot, sensor });
  });
  menuCo.addEventListener('click', function() {
    title.innerHTML = 'CO';
    sensor = ['1'];
    van = document.querySelector('.js-date-van').value + ' ' + document.querySelector('.js-time-van').value;
    tot = document.querySelector('.js-date-tot').value + ' ' + document.querySelector('.js-time-tot').value;
    socket.emit('geschiedenis', { van, tot, sensor });
  });
  let today = new Date();
  t = document.querySelector('.js-temperatuur');
  v = document.querySelector('.js-vochtigheid');
  l = document.querySelector('.js-luchtdruk');
  co2 = document.querySelector('.js-co2');
  co = document.querySelector('.js-co');
  title = document.querySelector('.js-title-sensor');
  title.innerHTML = 'Temperatuur';
  enableSocketIO();

  document.querySelector('.js-date-van').value = new Date(Date.now() - 86400000).toJSON().slice(0, 10);
  document.querySelector('.js-date-tot').value = today.toJSON().slice(0, 10);

  sensor = ['7', '4'];
  van = document.querySelector('.js-date-van').value + ' ' + document.querySelector('.js-time-van').value;
  tot = document.querySelector('.js-date-tot').value + ' ' + document.querySelector('.js-time-tot').value;
  socket.emit('geschiedenis', { van, tot, sensor });

  document.querySelector('.js-go').addEventListener('click', function() {
    van = document.querySelector('.js-date-van').value + ' ' + document.querySelector('.js-time-van').value;
    tot = document.querySelector('.js-date-tot').value + ' ' + document.querySelector('.js-time-tot').value;
    socket.emit('geschiedenis', { van, tot, sensor });
  });
  t.addEventListener('click', function() {
    title.innerHTML = 'Temperatuur';
    sensor = ['7', '4'];
    resetMenu();
    this.classList = 'c-menu-item c-menu-item-selected';
    van = document.querySelector('.js-date-van').value + ' ' + document.querySelector('.js-time-van').value;
    tot = document.querySelector('.js-date-tot').value + ' ' + document.querySelector('.js-time-tot').value;
    socket.emit('geschiedenis', { van, tot, sensor });
  });
  v.addEventListener('click', function() {
    title.innerHTML = 'Vochtigheid';

    sensor = ['3'];
    resetMenu();
    this.classList = 'c-menu-item c-menu-item-selected';
    van = document.querySelector('.js-date-van').value + ' ' + document.querySelector('.js-time-van').value;
    tot = document.querySelector('.js-date-tot').value + ' ' + document.querySelector('.js-time-tot').value;
    socket.emit('geschiedenis', { van, tot, sensor });
  });
  l.addEventListener('click', function() {
    title.innerHTML = 'Luchtdruk';
    sensor = ['5'];
    resetMenu();
    this.classList = 'c-menu-item c-menu-item-selected';
    van = document.querySelector('.js-date-van').value + ' ' + document.querySelector('.js-time-van').value;
    tot = document.querySelector('.js-date-tot').value + ' ' + document.querySelector('.js-time-tot').value;
    socket.emit('geschiedenis', { van, tot, sensor });
  });
  co2.addEventListener('click', function() {
    title.innerHTML = 'CO2';
    sensor = ['2'];
    resetMenu();
    this.classList = 'c-menu-item c-menu-item-selected';
    van = document.querySelector('.js-date-van').value + ' ' + document.querySelector('.js-time-van').value;
    tot = document.querySelector('.js-date-tot').value + ' ' + document.querySelector('.js-time-tot').value;
    socket.emit('geschiedenis', { van, tot, sensor });
  });
  co.addEventListener('click', function() {
    title.innerHTML = 'CO';
    sensor = ['1'];
    resetMenu();
    this.classList = 'c-menu-item c-menu-item-selected';
    van = document.querySelector('.js-date-van').value + ' ' + document.querySelector('.js-time-van').value;
    tot = document.querySelector('.js-date-tot').value + ' ' + document.querySelector('.js-time-tot').value;
    socket.emit('geschiedenis', { van, tot, sensor });
  });
};

document.addEventListener('DOMContentLoaded', function() {
  console.info('DOM geladen');
  init();
});

// #endregion
