// #region Algemeen
//const IP = prompt('geef publiek IP', 'http://127.0.0.1:5000');
const IP = window.location.hostname + ':5000';
//const IP = '169.254.10.1' + ':5000';

const socket = io.connect(IP);
let wwButton, rgbButton, kwButton;
const enableSocketIO = function() {
  socket.on('connected', function() {
    console.log('connected');
  });
  socket.on('response', function(response) {
    console.log('response: ', response);
  });
};

const rgbColor = function(color) {
  document.bgColor = color;

  let a = color.match(/[A-Za-z0-9]{2}/g).map(function(v) {
    return pad(parseInt(v, 16), 3, 0);
  });
  return a;
};

function pad(n, width, z) {
  z = z || '0';
  n = n + '';
  return n.length >= width ? n : new Array(width - n.length + 1).join(z) + n;
}

const init = function() {
  menu = document.querySelector('.js-menu-button');
  menuContent = document.querySelector('.js-menu-content');
  menu.addEventListener('click', function() {
    menuContent.classList.toggle('c-nav-dropdown-show');
  });
  enableSocketIO();
  socket.emit('DOMloaded');
  wwButton = document.querySelector('.js-toggle-ww');
  rgbButton = document.querySelector('.js-toggle-rgb');
  kwButton = document.querySelector('.js-toggle-kw');
  wwSlider = document.querySelector('.js-slider-ww');
  rgbSlider = document.querySelector('.js-slider-rgb');
  kwSlider = document.querySelector('.js-slider-kw');
  rgbColorpicker = document.querySelector('.js-rgb');
  wwButton.addEventListener('click', function() {
    resetButtons();
    this.classList.toggle('c-licht-button-disabled');
    this.classList.toggle('c-licht-button-active');
    this.innerHTML = 'on';
    ww();
    wwSlider.addEventListener('change', ww);
  });
  rgbButton.addEventListener('click', function() {
    resetButtons();
    this.classList.toggle('c-licht-button-disabled');
    this.classList.toggle('c-licht-button-active');
    this.innerHTML = 'on';
    rgb();
    rgbSlider.addEventListener('change', rgb);
    rgbColorpicker.addEventListener('input', rgb);
  });
  kwButton.addEventListener('click', function() {
    resetButtons();
    this.classList.toggle('c-licht-button-disabled');
    this.classList.toggle('c-licht-button-active');
    this.innerHTML = 'on';
    kw();
    kwSlider.addEventListener('change', kw);
  });
};

const resetButtons = function() {
  wwButton.classList = 'c-licht-button-disabled';
  rgbButton.classList = 'c-licht-button-disabled';
  kwButton.classList = 'c-licht-button-disabled';
  wwButton.innerHTML = 'off';
  rgbButton.innerHTML = 'off';
  kwButton.innerHTML = 'off';
  wwSlider.removeEventListener('change', ww);
  rgbSlider.removeEventListener('change', rgb);
  kwSlider.removeEventListener('change', kw);
  rgbColorpicker.removeEventListener('input', rgb);
};

const ww = function() {
  socket.emit('rgb', [255, 255, 50, wwSlider.value]);
};
const rgb = function() {
  let color = rgbColor(rgbColorpicker.value);
  color.push(rgbSlider.value);
  socket.emit('rgb', color);
};
const kw = function() {
  socket.emit('rgb', [255, 255, 255, kwSlider.value]);
};

const manual = function(message) {
  console.log('sending: ', message);
  socket.emit('manual', message);
};

document.addEventListener('DOMContentLoaded', function() {
  console.info('DOM geladen');
  init();
});

// #endregion
